# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CmxapiresourcestmcendpointsrequesttrackerEndpointProperties(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'agent_id': 'str',
        'api_endpoint': 'str',
        'api_token': 'str',
        'ca_certificate': 'str',
        'certificate': 'str',
        'credentials_type': 'str',
        'dc_id': 'str',
        'default_cluster_group_name': 'str',
        'default_workspace_name': 'str',
        'direct_connection': 'bool',
        'org_id': 'str',
        'private_key': 'str',
        'private_key_id': 'str',
        'public_key': 'str',
        'skip_cert_validation': 'bool',
        'user_email': 'str'
    }

    attribute_map = {
        'agent_id': 'agentId',
        'api_endpoint': 'apiEndpoint',
        'api_token': 'apiToken',
        'ca_certificate': 'caCertificate',
        'certificate': 'certificate',
        'credentials_type': 'credentialsType',
        'dc_id': 'dcId',
        'default_cluster_group_name': 'defaultClusterGroupName',
        'default_workspace_name': 'defaultWorkspaceName',
        'direct_connection': 'directConnection',
        'org_id': 'orgId',
        'private_key': 'privateKey',
        'private_key_id': 'privateKeyId',
        'public_key': 'publicKey',
        'skip_cert_validation': 'skipCertValidation',
        'user_email': 'userEmail'
    }

    def __init__(self, agent_id=None, api_endpoint=None, api_token=None, ca_certificate=None, certificate=None, credentials_type=None, dc_id=None, default_cluster_group_name=None, default_workspace_name=None, direct_connection=None, org_id=None, private_key=None, private_key_id=None, public_key=None, skip_cert_validation=None, user_email=None):  # noqa: E501
        """CmxapiresourcestmcendpointsrequesttrackerEndpointProperties - a model defined in Swagger"""  # noqa: E501
        self._agent_id = None
        self._api_endpoint = None
        self._api_token = None
        self._ca_certificate = None
        self._certificate = None
        self._credentials_type = None
        self._dc_id = None
        self._default_cluster_group_name = None
        self._default_workspace_name = None
        self._direct_connection = None
        self._org_id = None
        self._private_key = None
        self._private_key_id = None
        self._public_key = None
        self._skip_cert_validation = None
        self._user_email = None
        self.discriminator = None
        if agent_id is not None:
            self.agent_id = agent_id
        if api_endpoint is not None:
            self.api_endpoint = api_endpoint
        if api_token is not None:
            self.api_token = api_token
        if ca_certificate is not None:
            self.ca_certificate = ca_certificate
        if certificate is not None:
            self.certificate = certificate
        if credentials_type is not None:
            self.credentials_type = credentials_type
        if dc_id is not None:
            self.dc_id = dc_id
        if default_cluster_group_name is not None:
            self.default_cluster_group_name = default_cluster_group_name
        if default_workspace_name is not None:
            self.default_workspace_name = default_workspace_name
        if direct_connection is not None:
            self.direct_connection = direct_connection
        if org_id is not None:
            self.org_id = org_id
        if private_key is not None:
            self.private_key = private_key
        if private_key_id is not None:
            self.private_key_id = private_key_id
        if public_key is not None:
            self.public_key = public_key
        if skip_cert_validation is not None:
            self.skip_cert_validation = skip_cert_validation
        if user_email is not None:
            self.user_email = user_email

    @property
    def agent_id(self):
        """Gets the agent_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The agent_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._agent_id

    @agent_id.setter
    def agent_id(self, agent_id):
        """Sets the agent_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param agent_id: The agent_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._agent_id = agent_id

    @property
    def api_endpoint(self):
        """Gets the api_endpoint of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The api_endpoint of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._api_endpoint

    @api_endpoint.setter
    def api_endpoint(self, api_endpoint):
        """Sets the api_endpoint of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param api_endpoint: The api_endpoint of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._api_endpoint = api_endpoint

    @property
    def api_token(self):
        """Gets the api_token of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The api_token of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._api_token

    @api_token.setter
    def api_token(self, api_token):
        """Sets the api_token of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param api_token: The api_token of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._api_token = api_token

    @property
    def ca_certificate(self):
        """Gets the ca_certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The ca_certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._ca_certificate

    @ca_certificate.setter
    def ca_certificate(self, ca_certificate):
        """Sets the ca_certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param ca_certificate: The ca_certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._ca_certificate = ca_certificate

    @property
    def certificate(self):
        """Gets the certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._certificate

    @certificate.setter
    def certificate(self, certificate):
        """Sets the certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param certificate: The certificate of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._certificate = certificate

    @property
    def credentials_type(self):
        """Gets the credentials_type of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The credentials_type of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._credentials_type

    @credentials_type.setter
    def credentials_type(self, credentials_type):
        """Sets the credentials_type of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param credentials_type: The credentials_type of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._credentials_type = credentials_type

    @property
    def dc_id(self):
        """Gets the dc_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The dc_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._dc_id

    @dc_id.setter
    def dc_id(self, dc_id):
        """Sets the dc_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param dc_id: The dc_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._dc_id = dc_id

    @property
    def default_cluster_group_name(self):
        """Gets the default_cluster_group_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The default_cluster_group_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._default_cluster_group_name

    @default_cluster_group_name.setter
    def default_cluster_group_name(self, default_cluster_group_name):
        """Sets the default_cluster_group_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param default_cluster_group_name: The default_cluster_group_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._default_cluster_group_name = default_cluster_group_name

    @property
    def default_workspace_name(self):
        """Gets the default_workspace_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The default_workspace_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._default_workspace_name

    @default_workspace_name.setter
    def default_workspace_name(self, default_workspace_name):
        """Sets the default_workspace_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param default_workspace_name: The default_workspace_name of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._default_workspace_name = default_workspace_name

    @property
    def direct_connection(self):
        """Gets the direct_connection of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The direct_connection of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: bool
        """
        return self._direct_connection

    @direct_connection.setter
    def direct_connection(self, direct_connection):
        """Sets the direct_connection of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param direct_connection: The direct_connection of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: bool
        """

        self._direct_connection = direct_connection

    @property
    def org_id(self):
        """Gets the org_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The org_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param org_id: The org_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def private_key(self):
        """Gets the private_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The private_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._private_key

    @private_key.setter
    def private_key(self, private_key):
        """Sets the private_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param private_key: The private_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._private_key = private_key

    @property
    def private_key_id(self):
        """Gets the private_key_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The private_key_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._private_key_id

    @private_key_id.setter
    def private_key_id(self, private_key_id):
        """Sets the private_key_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param private_key_id: The private_key_id of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._private_key_id = private_key_id

    @property
    def public_key(self):
        """Gets the public_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The public_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """Sets the public_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param public_key: The public_key of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._public_key = public_key

    @property
    def skip_cert_validation(self):
        """Gets the skip_cert_validation of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The skip_cert_validation of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: bool
        """
        return self._skip_cert_validation

    @skip_cert_validation.setter
    def skip_cert_validation(self, skip_cert_validation):
        """Sets the skip_cert_validation of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param skip_cert_validation: The skip_cert_validation of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: bool
        """

        self._skip_cert_validation = skip_cert_validation

    @property
    def user_email(self):
        """Gets the user_email of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501


        :return: The user_email of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :rtype: str
        """
        return self._user_email

    @user_email.setter
    def user_email(self, user_email):
        """Sets the user_email of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.


        :param user_email: The user_email of this CmxapiresourcestmcendpointsrequesttrackerEndpointProperties.  # noqa: E501
        :type: str
        """

        self._user_email = user_email

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CmxapiresourcestmcendpointsrequesttrackerEndpointProperties, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CmxapiresourcestmcendpointsrequesttrackerEndpointProperties):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
